import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import ddf.minim.spi.*; 
import ddf.minim.signals.*; 
import ddf.minim.*; 
import ddf.minim.analysis.*; 
import ddf.minim.ugens.*; 
import ddf.minim.effects.*; 
import sprites.utils.*; 
import sprites.maths.*; 
import sprites.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Setubun extends PApplet {








public boolean KEY_RIGHT = false;
public boolean KEY_LEFT = false;
public boolean KEY_UP = false;
public boolean KEY_DOWN = false;
public boolean KEY_SPACE = false;

MyGame _game;

Minim _minim;
AudioPlayer _titlePlayer, _selectPlayer, _throwPlayer, _hitPlayer, _gameOverPlayer;

public void setup(){
  size(1024,768);
  _game = new MyGame(this);
  _minim = new Minim(this);
  _titlePlayer = _minim.loadFile( "Title.mp3" );
  _selectPlayer = _minim.loadFile( "Select.mp3" );
  _throwPlayer = _minim.loadFile( "Throw.mp3" );
  _hitPlayer = _minim.loadFile( "Hit.mp3" );
  _gameOverPlayer = _minim.loadFile( "GameOver.mp3" );
}

public void draw(){
  _game.run();
}

public void keyPressed(){  
  switch(key){
    case 'w':
      KEY_UP = true;
      break;
    case 's':
      KEY_DOWN = true;
      break;
    case 'd':
      KEY_RIGHT = true;
      break;
    case 'a':
      KEY_LEFT = true;
      break;
   case ' ':
      KEY_SPACE = true;
      break;
  }
}

public void keyReleased()
{
  switch(key){
    case 'w':
      KEY_UP = false;
      break;
    case 's':
      KEY_DOWN = false;
      break;
    case 'd':
      KEY_RIGHT = false;
      break;
    case 'a':
      KEY_LEFT = false;
      break;
   case ' ':
      KEY_SPACE = false;
      break;
  }
}

public void titleSound()
{
  _titlePlayer.loop();
}

public void selectSound()
{
  _selectPlayer.play();
  _selectPlayer.rewind();
}

public void throwSound()
{
  _throwPlayer.play();
  _throwPlayer.rewind();
}

public void hitSound()
{
  _hitPlayer.play();
  _hitPlayer.rewind();
}

public void gameOverSound()
{
  _gameOverPlayer.play();
  _gameOverPlayer.rewind();
}











class BaseCharacter {
  // ---- field( Start ) ----
  protected Game _parent;      // 
  private Sprite _sprite;    // Character image
  public Vector2D position;  // Character position
  private int _cols;
  public int state;          // Current state
  // ---- field( End ) ----
  
  // ---- method( Start ) ----
  // ---- constructor( Start ) ----
  BaseCharacter ( Game parent, String spriteName, int cols, int rows ) {
    // Initialize each parameter 
    _parent = parent;
    position = new Vector2D( 0, 0 );
    _sprite = new Sprite( _parent.applet, spriteName, cols, rows, 0 );
    _cols = cols;
    state = 0;
  }
  // ---- constructor( End ) ----
  
  /* Collision detection method
     true : Hit   false : Not hit */
  public boolean hitTest( BaseCharacter target, double distance ) {
    // distance method : Calculate the distance between two points
    if( position.distance( target.position ) < distance ){
      return true;    // Hit
    }
    return false;     // Not hit
  }
  
  public boolean hitTestWall( BaseCharacter target, PImage image ) {
    // distance method : Calculate the distance between two points
    if( (int)target.position.x -30 < ((int)this.position.x+image.width/2) && (int)target.position.y-30 < ((int)this.position.y + image.height/2)
        && (int)target.position.x+30 > ((int)this.position.x-image.width/2)&& (int)target.position.y+30 > ((int)this.position.y - image.height/2)){
      return true;    // Hit
    }
    return false;     // Not hit
  }
  
  // Update : Override when extends
  public void update ( double deltaTime ){
    _sprite.setPos( position );
    _sprite.update( deltaTime );
    _sprite.draw();
  }
  
  
  // Change animation
  public void changeAnimation( int pattern ) {
    if( pattern < _cols && pattern >= 0) {
      _sprite.setFrameSequence( _cols * pattern, _cols * pattern + _cols - 1, 0.1f );
    } else {
      _sprite.setFrameSequence( _cols * pattern, _cols * pattern + _cols - 1, 0.1f );
    }
  }
  
  // ---- method( End ) ----
}
class Beans extends BaseCharacter {
  int _dx, _dy;
  int _x, _y;  
  boolean _alive;
  int count;
  int moveCount;
  int moveWay;
  public static final int WIDTH = 128;
  public static final int HEIGHT = 128;
  private final int IMAGE_WIDTH = 4;
  private final int IMAGE_HEIGHT = 6;

  public Beans( Game parent ) {
    super( parent, "beans.png", 5, 4 );
    _alive = false;
    count = 0;
    moveCount = 0;
  }

  public void update( double deltaTime ) {
    MyGame theParent = (MyGame)_parent;
    if (_alive) {
      if (moveCount <= 128) {
        if(moveWay == 0){
          _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT - moveCount  + WIDTH/2;
        }
        else if(moveWay == 1){
          _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount  + WIDTH/2;
        }
        else if(moveWay == 2){
          _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH + moveCount + WIDTH/2;
        }
        else if(moveWay == 3){
          _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH - moveCount + WIDTH/2;
        }
        else if(moveWay == 4){
          _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount  + WIDTH/2;
        }
        moveCount++;
        if( hitTest( ((MyGame)_parent)._oni, 50.0f ) ){
          theParent._oni.moveCount = 0;
          theParent._oni.hit(moveWay);
          theParent.beansFlag = true;
        }
      } else {
        _alive = false;
        theParent.beansFlag = true;
      }
      position.x = _x;
      position.y = _y;

      super.update( deltaTime );
    }
  }

  public void initialize( int dy, int dx , int way) {
    MyGame theParent = (MyGame)_parent;
    moveWay = way;
    _dy = dy;
    _dx = dx;
    _x = ( _dx * WIDTH ) + WIDTH / 2  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH;
    _y = ( _dy * HEIGHT ) + HEIGHT / 2 - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT;
    position.set(_x, _y);
    _alive = true;
  }
}

class CreateMap{
  
  
  private PImage mapChip = loadImage("mapImage.jpg");
  private PImage[] mapChips = new PImage[24];
  private String lines[];
  private int[][] map;
  private int[][] provisionalMap;
  private final int MAP_HIGHT_LENGTH = 10;
  private int mapWidth;
  private int playerX, playerY;
  private final int MAX_WIDTH = 8;
  private final int MAX_HEIGHT = 6;
  public static final int WIDTH = 128;
  public static final int HEIGHT = 128;
  private final int IMAGE_WIDTH = 4;
  private final int IMAGE_HEIGHT = 6;
  
  public CreateMap(){
     
  }
  
  protected void initialize () {
    //csv load
    lines = loadStrings("map.csv");
    int mapWidth = lines[0].split(",").length;
    map = new int [lines.length][mapWidth];
    for(int i = 0; i < lines.length; i++){
      String[] values = lines[i].split(",");
      for(int j = 0; j < mapWidth; j++){
        map[i][j] = PApplet.parseInt(values[j]);
      }
    }
    
    for(int i = 0; i < IMAGE_HEIGHT;i++){
      for(int j = 0; j < IMAGE_WIDTH; j++){
        mapChips[i*4+j] = mapChip.get(j*128, i*128,128,128);
      }
    }
  }
  
  protected void update(){
    
  }
  
  public void drawMapChip(){
    for(int i = 0; i < map.length; i++){
        for(int j = 0; j < map[0].length; j++){
          image(mapChips[map[i][j]], (float)(j * WIDTH + WIDTH / 2 - WIDTH * (map[0].length / 2) + IMAGE_WIDTH * WIDTH), (float)(i * HEIGHT + HEIGHT / 2 - HEIGHT * (map.length / 2) + IMAGE_HEIGHT * HEIGHT));
        }
    }
  }
  
}
class Game {
  // ---- field( Start ) ----
  private boolean _firstTime;
  public PApplet applet;
  private StopWatch _timer;
  public double delta;
  // ---- field( End ) ----
  
  
  // ---- method( Start ) ----
  
  // ---- constructor( Start ) ----
  Game( PApplet applet ) {
    this.applet = applet;
    _firstTime = true;
    _timer = new StopWatch();
  }
  // ---- constructor( End ) ----
  
  // Initialize : override when extends
  protected void initialize () {
    _firstTime = false;
  }
  
  // Game :  Override when extends
  protected void update(){
  }
  
  // Update : Override when extends
  protected void run() {
    if( _firstTime ) {
      initialize();
    } else {
      update();
    }
    delta = _timer.getElapsedTime();
  }
  // ---- method( End ) ----
}
class MyGame extends Game {
  public static final int SCENE_TITLE = 0, SCENE_GAME = 1, 
  SCENE_GAMEOVER = 2, SCENE_GAMECLEAR = 3;
  private int scene;
  private PImage titleImage, subTitleImage, pressKeyImage, gameOverImage, gameClearImage, oniImage;
  private boolean fade = false;
  private float pressedAt;
  private float frequency = 5000;
  private PImage light = loadImage("light.png");
  public static final int MAX_BEANS = 30;
  public boolean beansFlag;
  
  CreateMap _createMap;
  Player _player;
  Oni _oni;
  Beans[] beans;
  
  public MyGame( PApplet applet ) {
    super( applet );
  }
 
  protected void initialize() {
    scene = SCENE_TITLE;
    titleImage = loadImage( "title.png" );
    subTitleImage = loadImage( "subTitle.png" );
    pressKeyImage = loadImage( "pressSpaceKey.png" );
    gameOverImage = loadImage( "gameOver.png" );
    gameClearImage = loadImage( "gameClear.png" );
    oniImage = loadImage( "oni.png" );
    imageMode( CENTER );
    _createMap = new CreateMap();
    _player = new Player(this);
    _oni = new Oni(this);
    beans = new Beans[MAX_BEANS];
    for(int i = 0; i < MAX_BEANS; i++){
      beans[i] = new Beans( this );
    }
    _createMap.initialize();
    _player.initialize(1,1);
    _oni.initialize(10,10);
    titleSound();
    beansFlag = true;
    super.initialize();
  }
  
  protected void update() {
    background(0);
    switch( scene )
    {
    case SCENE_TITLE:
      title();
      break;

    case SCENE_GAME:
      game();
      break;

    case SCENE_GAMEOVER:
      gameOver();
      break;

    case SCENE_GAMECLEAR:
      gameClear();
      break;
    }
    if ( fade ) {
      fill( 0, - 128*cos( TWO_PI/frequency*(millis()-pressedAt)) + 128);
      rect( 0, 0, width, height );
      if (millis()-pressedAt >= frequency) {
        fade = false;
      }
    }
  }
  
  private void title()
  {
    tint(255);
    image( oniImage, width, height / 2 );
    image( titleImage, width / 3, height / 3.1f );
    image( subTitleImage, width / 3, height / 2.1f );
    if ( KEY_SPACE && fade == false)
    {
      setMsec();
      selectSound();
    } else {
      float blinkTimer = millis();
      tint( 255, 128*sin( TWO_PI/frequency*blinkTimer) + 128 );
      image( pressKeyImage, width / 3, height / 1.3f );
    }

    if ((millis() - pressedAt >= frequency / 2) && fade ) {
      scene = SCENE_GAME;
    }
  }

  private void setMsec() {
    fade = true;
    pressedAt = millis();
  }

  private void game() 
  {
    pushMatrix();
    translate((float)(-_player.position.x + width / 2),(float)(-_player.position.y+ height / 2));
    _createMap.drawMapChip();
    _player.update(delta);
    _oni.update(delta);
    for(int i = 0; i < MAX_BEANS; i++){
      beans[i].update(delta);
    }
    tint(255);
    image(light,(float)(_player.position.x - WIDTH/2),(float)(_player.position.y - HEIGHT/2));
    popMatrix();
    if(_player.beansCount == MAX_BEANS){
      scene = SCENE_GAMEOVER;
    }
    if(_createMap.map[_oni._dy][_oni._dx] == 16){
      scene = SCENE_GAMECLEAR;
    }
  }

  private void gameOver()
  {
    image( oniImage, width / 2, height / 2 );
    image( gameOverImage, width / 2, height / 2.5f );
    if ( KEY_SPACE ) {
      setMsec();
    } else {
      if ((millis()-pressedAt >= frequency /2) && fade) {
        scene = SCENE_TITLE;
      }
    }
  }


  private void gameClear()
  {
    image( gameClearImage, width / 2, height / 2.5f );
    image( pressKeyImage, width / 2, height / 1.3f );
    if ( KEY_SPACE ) {
      setMsec();
    } else {
      if ((millis()-pressedAt >= frequency/2) && fade) {
        scene = SCENE_TITLE;
      }
    }
  }
  
}
class Oni extends BaseCharacter {
  public static final int STATE_WAIT = 0;
  public static final int STATE_MOVE_TO_RIGHT = 1;
  public static final int STATE_MOVE_TO_LEFT = 2;
  public static final int STATE_MOVE_TO_UP = 3;
  public static final int STATE_MOVE_TO_DOWN = 4;
  public static final int STATE_MOVE_TO_DASH_RIGHT = 5;
  public static final int STATE_MOVE_TO_DASH_LEFT = 6;
  public static final int STATE_MOVE_TO_DASH_UP = 7;
  public static final int STATE_MOVE_TO_DASH_DOWN = 8;
  public static final int STATE_HIT = 9;

  public static final int ANIM_MOVE_TO_LEFT = 1;
  public static final int ANIM_MOVE_TO_RIGHT = 0;
  public static final int ANIM_MOVE_TO_UP = 2;
  public static final int ANIM_MOVE_TO_DOWN = 3;
  public static final int ANIM_MOVE_TO_DASH_LEFT = 6;
  public static final int ANIM_MOVE_TO_DASH_RIGHT = 4;
  public static final int ANIM_MOVE_TO_DASH_UP = 7;
  public static final int ANIM_MOVE_TO_DASH_DOWN = 5;

  public int _state;
  private int speed = 40;
  private int waitCount;
  private int fx = 0;
  private int fy = 0;
  public boolean hitFlag;

  private int moveCount;

  private int moveWay;
  private float _x, _y;
  private int _dx, _dy;
  public static final int WIDTH = 128;
  public static final int HEIGHT = 128;
  private final int IMAGE_WIDTH = 4;
  private final int IMAGE_HEIGHT = 6;

  public Oni( Game parent ) {
    super( parent, "oniAnim.png", 8, 8 );
    _state = STATE_WAIT;
    waitCount = 0;
    moveCount = 0;
    hitFlag = false;
  }

  public void initialize( int dx, int dy ) {
    MyGame theParent = (MyGame)_parent;
    _dx = dx;
    _dy = dy;
    _x = ( _dx * WIDTH ) + WIDTH /2  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH;
    _y = ( _dy * HEIGHT ) + HEIGHT /2 - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT;
    position.set( _x, _y );
  }

  public void update( double deltaTime ) {
    switch( _state ) {
    case STATE_WAIT:
      _state = waitInput();
      break;
    case STATE_MOVE_TO_RIGHT:
      _state = moveToRight();
      break;
    case STATE_MOVE_TO_LEFT:
      _state = moveToLeft();
      break;
    case STATE_MOVE_TO_UP:
      _state = moveToUp();
      break;
    case STATE_MOVE_TO_DOWN:
      _state = moveToDown();
      break;
    case STATE_MOVE_TO_DASH_RIGHT:
      _state = moveToDashRight();
      break;
    case STATE_MOVE_TO_DASH_LEFT:
      _state = moveToDashLeft();
      break;
    case STATE_MOVE_TO_DASH_UP:
      _state = moveToDashUp();
      break;
    case STATE_MOVE_TO_DASH_DOWN:
      _state = moveToDashDown();
      break;
    case STATE_HIT:
      break;
    }


    //------
    super.update( deltaTime );
  }

  private int waitInput() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;

    if (moveCount == 0) {
      if (this._dx + 2 == theParent._player._dx && this._dy == theParent._player._dy) {
        result = STATE_MOVE_TO_DASH_RIGHT;
        return result;
      }
      if (this._dx - 2 == theParent._player._dx && this._dy == theParent._player._dy) {
        result = STATE_MOVE_TO_DASH_LEFT;
        return result;
      }
      if (this._dy - 2 == theParent._player._dy && this._dx == theParent._player._dx) {
        result = STATE_MOVE_TO_DASH_UP;
        return result;
      }
      if (this._dy + 2 == theParent._player._dy && this._dx == theParent._player._dx) {
        result = STATE_MOVE_TO_DASH_DOWN;
        return result;
      }
      moveWay = PApplet.parseInt(random(1, 5));

      if (moveWay == STATE_MOVE_TO_RIGHT) {
        if ( theParent._createMap.map[_dy][_dx + 1] <= 1 || theParent._createMap.map[_dy][_dx + 1] >= 17) {
          result = STATE_WAIT;
        } else {
          result = STATE_MOVE_TO_RIGHT;
        }
      } else if (moveWay == STATE_MOVE_TO_LEFT) {
        if ( theParent._createMap.map[_dy][_dx - 1] <= 1 || theParent._createMap.map[_dy][_dx - 1] >= 17) {
          result = STATE_WAIT;
        } else {
          result = STATE_MOVE_TO_LEFT;
        }
      } else if (moveWay == STATE_MOVE_TO_UP) {
        if ( theParent._createMap.map[_dy - 1][_dx] <= 1 || theParent._createMap.map[_dy - 1][_dx] >= 17) {
          result = STATE_WAIT;
        } else {
          result = STATE_MOVE_TO_UP;
        }
      } else if (moveWay == STATE_MOVE_TO_DOWN) {
        if ( theParent._createMap.map[_dy + 1][_dx] <= 1 || theParent._createMap.map[_dy + 1][_dx] >= 17) {
          result = STATE_WAIT;
        } else {
          result = STATE_MOVE_TO_DOWN;
        }
      }
    }

    return result;
  } 


  private int moveToRight() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_RIGHT );
    if (moveCount <= 128) {
      _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH + moveCount + WIDTH/2;
      moveCount++;
    } else {
      _dx++;
      result = STATE_WAIT;
      moveCount = 0;
    }
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToLeft() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_LEFT );
    if (moveCount <= 128) {
      _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH - moveCount + WIDTH/2;
      moveCount++;
    } else {
      _dx--;
      result = STATE_WAIT;
      moveCount = 0;
    }
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToUp() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_UP );
    if (moveCount <= 128) {
      _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT - moveCount  + WIDTH/2;
      moveCount++;
    } else {
      _dy--;
      result = STATE_WAIT;
      moveCount = 0;
    }
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToDown() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_DOWN );
    if (moveCount <= 128) {
      _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount  + WIDTH/2;
      moveCount++;
    } else {
      _dy++;    
      result = STATE_WAIT;
      moveCount = 0;
    }
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToDashRight() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    if ( theParent._createMap.map[_dy][_dx + 1] >= 2 || theParent._createMap.map[_dy][_dx + 1] <= 15) {
      if ( theParent._createMap.map[_dy][_dx + 2] >= 2 || theParent._createMap.map[_dy][_dx + 2] <= 15) {
        changeAnimation( ANIM_MOVE_TO_DASH_RIGHT );
        if (moveCount <= 128) {
          _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH + moveCount*2 + WIDTH/2;
          moveCount++;
        } else {
          _dx += 2;
          result = STATE_WAIT;
          moveCount = 0;
        }
        position.x = _x;
        position.y = _y;
      }
    } else {
      result = STATE_WAIT;
    }
    return result;
  }

  private int moveToDashLeft() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    if ( theParent._createMap.map[_dy][_dx - 1] >= 2 || theParent._createMap.map[_dy][_dx - 1] <= 15) {
      if ( theParent._createMap.map[_dy][_dx - 2] >= 2 || theParent._createMap.map[_dy][_dx - 2] <= 15) {
        changeAnimation( ANIM_MOVE_TO_DASH_LEFT );
        if (moveCount <= 128) {
          _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH - moveCount*2 + WIDTH/2;
          moveCount++;
        } else {
          _dx-=2;
          result = STATE_WAIT;
          moveCount = 0;
        }
        position.x = _x;
        position.y = _y;
      }
    } else {
      result = STATE_WAIT;
    }
    return result;
  }


  private int moveToDashUp() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    if ( theParent._createMap.map[_dy - 1][_dx] >= 2 || theParent._createMap.map[_dy - 1][_dx] <= 15) {
      if ( theParent._createMap.map[_dy - 2][_dx] >= 2 || theParent._createMap.map[_dy - 2][_dx] <= 15) {
        changeAnimation( ANIM_MOVE_TO_DASH_UP );
        if (moveCount <= 128) {
          _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT - moveCount*2  + WIDTH/2;
          moveCount++;
        } else {
          _dy-=2;
          result = STATE_WAIT;
          moveCount = 0;
        }
        position.x = _x;
        position.y = _y;
      }
    } else {
      result = STATE_WAIT;
    }
    return result;
  }

  private int moveToDashDown() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    if ( theParent._createMap.map[_dy + 1][_dx] >= 2 || theParent._createMap.map[_dy + 1][_dx] <= 15) {
      if ( theParent._createMap.map[_dy + 2][_dx] >= 2 || theParent._createMap.map[_dy + 2][_dx] <= 15) {
        changeAnimation( ANIM_MOVE_TO_DASH_DOWN );
        if (moveCount <= 128) {
          _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount*2  + WIDTH/2;
          moveCount++;
        } else {
          _dy+=2;    
          result = STATE_WAIT;
          moveCount = 0;
        }
        position.x = _x;
        position.y = _y;
      }
    } else {
      result = STATE_WAIT;
    }
    return result;
  }
  public void hit(int moveWay) {
    _state = STATE_HIT;
    MyGame theParent = (MyGame)_parent;

    if (moveWay == 1) {
      changeAnimation( ANIM_MOVE_TO_DASH_DOWN );
      if (moveCount <= 128) {
        _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount*2  + WIDTH/2;
        moveCount++;
      } else {
        _dy+=2;    
        _state = STATE_WAIT;
        moveCount = 0;
      }
      position.x = _x;
      position.y = _y;
    } else if (moveWay == 0) {
      changeAnimation( ANIM_MOVE_TO_DASH_UP );
      if (moveCount <= 128) {
        _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT - moveCount*2  + WIDTH/2;
        moveCount++;
      } else {
        _dy-=2;
        _state = STATE_WAIT;
        moveCount = 0;
      }
      position.x = _x;
      position.y = _y;
    } else if (moveWay == 2) {
      changeAnimation( ANIM_MOVE_TO_DASH_RIGHT );
      if (moveCount <= 128) {
        _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH + moveCount*2 + WIDTH/2;
        moveCount++;
      } else {
        _dx += 2;
        _state = STATE_WAIT;
        moveCount = 0;
      }
      position.x = _x;
      position.y = _y;
    } else if (moveWay == 3) {
      changeAnimation( ANIM_MOVE_TO_DASH_LEFT );
      if (moveCount <= 128) {
        _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH - moveCount*2 + WIDTH/2;
        moveCount++;
      } else {
        _dx-=2;
        _state = STATE_WAIT;
        moveCount = 0;
      }
      position.x = _x;
      position.y = _y;
    } else if (moveWay == 4) {
      changeAnimation( ANIM_MOVE_TO_DASH_UP );
      if (moveCount <= 128) {
        _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount*2  + WIDTH/2;
        moveCount++;
      } else {
        _dy-=2;
        _state = STATE_WAIT;
        moveCount = 0;
      }
      position.x = _x;
      position.y = _y;
    }
  }
}

class Player extends BaseCharacter {
  public static final int STATE_WAIT = 0;
  public static final int STATE_MOVE_TO_RIGHT = 1;
  public static final int STATE_MOVE_TO_LEFT = 2;
  public static final int STATE_MOVE_TO_UP = 3;
  public static final int STATE_MOVE_TO_DOWN = 4;
  public static final int STATE_MOVE_TO_URIGHT = 5;
  public static final int STATE_MOVE_TO_ULEFT = 6;
  public static final int STATE_MOVE_TO_DRIGHT = 7;
  public static final int STATE_MOVE_TO_DLEFT = 8;
  public static final int STATE_THROW = 9;

  public static final int ANIM_MOVE_TO_LEFT = 2;
  public static final int ANIM_MOVE_TO_RIGHT = 3;
  public static final int ANIM_MOVE_TO_UP = 0;
  public static final int ANIM_MOVE_TO_DOWN = 1;  

  public int beansCount = 0;
  private int moveCount;  
  public int direction = 0;
  private int speed = 3;
  private int _state;
  private int _dx, _dy;
  private float _x, _y;
  public static final int WIDTH = 128;
  public static final int HEIGHT = 128;
  private final int IMAGE_WIDTH = 4;
  private final int IMAGE_HEIGHT = 6;


  public Player( Game parent ) {
    super( parent, "player.png", 8, 4 );
    _state = STATE_WAIT;
    moveCount = 0;
  }

  public void initialize(int dx, int dy) {
    MyGame theParent = (MyGame)_parent;
    _dx = dx;
    _dy = dy;
    _x = ( _dx * WIDTH ) + WIDTH / 2  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH;
    _y = ( _dy * HEIGHT ) + HEIGHT / 2 - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT;
    position.set(_x, _y);
  }

  public void update( double deltaTime ) {
    switch( _state ) {
    case STATE_WAIT:
      _state = waitInput();
      break;
    case STATE_MOVE_TO_RIGHT:
      _state = moveToRight();
      break;
    case STATE_MOVE_TO_LEFT:
      _state = moveToLeft();
      break;
    case STATE_MOVE_TO_UP:
      _state = moveToUp();
      break;
    case STATE_MOVE_TO_DOWN:
      _state = moveToDown();
      break;
    case STATE_THROW:
      _state = throwBeans();
      break;
    }

    //------
    super.update( deltaTime );
  }




  private int waitInput() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( 1 );
    if (KEY_RIGHT) {
      if ( theParent._createMap.map[_dy][_dx + 1] <= 1 || theParent._createMap.map[_dy][_dx + 1] >= 16) {
        result = STATE_WAIT;
      } else {
        result = STATE_MOVE_TO_RIGHT;
      }
    } else if (KEY_LEFT) {
      if ( theParent._createMap.map[_dy][_dx - 1] <= 1 || theParent._createMap.map[_dy][_dx - 1] >= 16) {
        result = STATE_WAIT;
      } else {
        result = STATE_MOVE_TO_LEFT;
      }
    } else if (KEY_UP) {
      if ( theParent._createMap.map[_dy - 1][_dx] <= 1 || theParent._createMap.map[_dy - 1][_dx] >= 16) {
        result = STATE_WAIT;
      } else {
        result = STATE_MOVE_TO_UP;
      }
    } else if (KEY_DOWN) {
      if ( theParent._createMap.map[_dy + 1][_dx] <= 1 || theParent._createMap.map[_dy + 1][_dx] >= 16) {
        result = STATE_WAIT;
      } else {
        result = STATE_MOVE_TO_DOWN;
      }
    } else if (KEY_SPACE) {
      result = STATE_THROW;
    }
    return result;
  } 

  private int moveToRight() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_RIGHT );
    if (moveCount <= 128) {
      _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH + moveCount + WIDTH/2;
      moveCount++;
    } else {
      _dx++;
      result = STATE_WAIT;
      moveCount = 0;
    }
    direction = STATE_MOVE_TO_RIGHT;
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToLeft() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_LEFT );
    if (moveCount <= 128) {
      _x = (_dx * WIDTH)  - WIDTH * (theParent._createMap.map[0].length / 2 )+ IMAGE_WIDTH * WIDTH - moveCount + WIDTH/2;
      moveCount++;
    } else {
      _dx--;
      result = STATE_WAIT;
      moveCount = 0;
    }
    direction = STATE_MOVE_TO_LEFT;
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToUp() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_UP );
    if (moveCount <= 128) {
      _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT - moveCount  + WIDTH/2;
      moveCount++;
    } else {
      _dy--;
      result = STATE_WAIT;
      moveCount = 0;
    }
    direction = STATE_MOVE_TO_UP;
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int moveToDown() {
    int result = _state;
    MyGame theParent = (MyGame)_parent;
    changeAnimation( ANIM_MOVE_TO_DOWN );
    if (moveCount <= 128) {
      _y = (_dy * HEIGHT) - HEIGHT * (theParent._createMap.map.length / 2) + IMAGE_HEIGHT * HEIGHT + moveCount  + WIDTH/2;
      moveCount++;
    } else {
      _dy++;    
      result = STATE_WAIT;
      moveCount = 0;
    }
    direction = STATE_WAIT;
    position.x = _x;
    position.y = _y;
    return result;
  }

  private int throwBeans() {
    MyGame theParent = (MyGame)_parent;
    int result = _state;
    if (beansCount <= 30 && theParent.beansFlag) {
      switch(direction) {
      case STATE_MOVE_TO_UP:
        theParent.beans[beansCount].initialize( _dy , _dx ,0);
        break;
      case STATE_MOVE_TO_DOWN:
        theParent.beans[beansCount].initialize( _dy , _dx ,1);
        break;
      case STATE_MOVE_TO_RIGHT:
        theParent.beans[beansCount].initialize( _dy, _dx ,2);
        break;
      case STATE_MOVE_TO_LEFT:
        theParent.beans[beansCount].initialize( _dy, _dx ,3);
        break;
      case STATE_WAIT:
        theParent.beans[beansCount].initialize( _dy, _dx ,4);
        break;
      default:
        println("default");
      }

      beansCount++;
      theParent.beansFlag = false;
    }
    result = STATE_WAIT;
    return result;
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "Setubun" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
