import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

public boolean KEY_RIGHT = false;
public boolean KEY_LEFT = false;
public boolean KEY_UP = false;
public boolean KEY_DOWN = false;
public boolean KEY_SPACE = false;

MyGame _game;

Minim _minim;
AudioPlayer _titlePlayer, _selectPlayer, _throwPlayer, _hitPlayer, _gameOverPlayer;

void setup(){
  size(1024,768);
  _game = new MyGame(this);
  _minim = new Minim(this);
  _titlePlayer = _minim.loadFile( "Title.mp3" );
  _selectPlayer = _minim.loadFile( "Select.mp3" );
  _throwPlayer = _minim.loadFile( "Throw.mp3" );
  _hitPlayer = _minim.loadFile( "Hit.mp3" );
  _gameOverPlayer = _minim.loadFile( "GameOver.mp3" );
}

void draw(){
  _game.run();
}

void keyPressed(){  
  switch(key){
    case 'w':
      KEY_UP = true;
      break;
    case 's':
      KEY_DOWN = true;
      break;
    case 'd':
      KEY_RIGHT = true;
      break;
    case 'a':
      KEY_LEFT = true;
      break;
   case ' ':
      KEY_SPACE = true;
      break;
  }
}

void keyReleased()
{
  switch(key){
    case 'w':
      KEY_UP = false;
      break;
    case 's':
      KEY_DOWN = false;
      break;
    case 'd':
      KEY_RIGHT = false;
      break;
    case 'a':
      KEY_LEFT = false;
      break;
   case ' ':
      KEY_SPACE = false;
      break;
  }
}

void titleSound()
{
  _titlePlayer.loop();
}

void selectSound()
{
  _selectPlayer.play();
  _selectPlayer.rewind();
}

void throwSound()
{
  _throwPlayer.play();
  _throwPlayer.rewind();
}

void hitSound()
{
  _hitPlayer.play();
  _hitPlayer.rewind();
}

void gameOverSound()
{
  _gameOverPlayer.play();
  _gameOverPlayer.rewind();
}







